<?xml version='1.0' encoding='UTF-8'?>
<!DOCTYPE Workflow PUBLIC "sailpoint.dtd" "sailpoint.dtd">
<Workflow explicitTransitions="true" name="BNT Workflow Add or Update Mobile Number">
  <Variable initializer="true" input="true" name="transient"/>
  <Variable name="identityName"/>
  <Variable input="true" name="quickLinkIdentityName"/>
  <Variable name="quickLinkIdentityId"/>
  <Variable initializer="script:(identityDisplayName != void) ? identityDisplayName : resolveDisplayName(quickLinkIdentityName)" input="true" name="identityDisplayName">
    <Description>The displayName of the identity being updated.

      Query for this using a projection query and fall back to the name.</Description>
  </Variable>
  <Variable name="plan"/>
  <Variable initializer="string:spadmin" input="true" name="launcher">
    <Description>The launcher fo the workflow</Description>
  </Variable>
  <Variable input="true" name="mobile"/>
  <Variable input="true" name="context">
    <Description>The SailPoint Context object</Description>
  </Variable>
  <Variable name="plan">
    <Description>The provisioning plan, which is built by a service method.</Description>
  </Variable>
  <Variable initializer="true" input="true" name="trace">
    <Description>Used for debugging this workflow and when set to true trace
      will be sent to stdout.</Description>
  </Variable>
  <Step icon="Start" name="start" posX="28" posY="10">
    <Transition to="Update Form"/>
  </Step>
  <Step icon="Analysis" name="Update Form" posX="97" posY="10">
    <Approval name="BNT Add or Update Mobile Number" owner="ref:launcher" return="quickLinkIdentityName, mobile" send="quickLinkIdentityName, mobile">
      <Form name="BNT Add or Update Mobile Number" type="WorkflowConfig">
        <Attributes>
          <Map>
            <entry key="pageTitle" value="BNT Add or Update Mobile Number"/>
          </Map>
        </Attributes>
        <Section label="Update Mobile Number" name="Update Form">
          <Field displayName="Select User" displayType="list" dynamic="true" filterString="workgroup==false &amp;&amp; !(name==&quot;spadmin&quot;)" name="quickLinkIdentityName" postBack="true" required="true" type="sailpoint.object.Identity"/>
          <Field dependencies="quickLinkIdentityName" displayName="Mobile Number" dynamic="true" helpKey="Example Format: +49 171 123-4567" name="mobile" postBack="true" required="true" type="string">
            <Script>
              <Source><![CDATA[
                import sailpoint.object.Identity;
                import org.apache.log4j.Logger;

                Logger logger = Logger.getLogger("biontech.workflow.BNT Workflow Add or Update Mobile Number");
                logger.debug("--- ENTRY ---");
                Identity identity = context.getObjectById(Identity.class, quickLinkIdentityName);
                if(null!=identity)
                {
                mobile = identity.getAttribute("mobile");
                logger.debug ("Success Factor Mobile Number:" +mobile);
                logger.debug("--- EXIT ---");

                return mobile;
                wfcase.put("mobile", identity.getAttribute("mobile"));
                }

              ]]></Source>
            </Script>
            <ValidationScript>
              <Source><![CDATA[
                import sailpoint.object.*;
                import sailpoint.tools.*;
                import org.apache.log4j.Logger;
                import java.util.regex.*; 
                import java.util.*; 
                
                Logger logger = Logger.getLogger("biontech.workflow.BNT Workflow Add or Update Mobile Number");
                logger.debug("--- ENTRY ---");
                logger.debug("Value is : " + value);

                String regex = "(\\+\\(?([\\d \\-\\)\\\u2013\\+\\/\\(]+){6,}\\)?([ .\\-\u2013\\/]?)([\\d]+))";
                String status = "";
                String mobile = "";

                Pattern p = Pattern.compile(regex);
                logger.debug("Pattern is : " + p);
                Matcher m = p.matcher(value.toString());
                logger.debug("Macher is : " + m.matches());

                if(m.matches().equals(true)){                
                status = "Valid Mobile Number Format";
                logger.debug("Status : " + status);
                mobile = value.toString();
                return mobile;
                }else if(!value.toString().matches(regex)){
                status = "Invalid Mobile Number Format";
                logger.debug("Status : " + status);
                return status;
                }

                logger.debug("--- EXIT ---");

              ]]></Source>
            </ValidationScript>
          </Field>
        </Section>
        <Button action="cancel" label="Cancel"/>
        <Button action="next" label="Submit"/>
      </Form>
    </Approval>
    <Arg name="mobile" value="ref:mobile"/>
    <Arg name="quickLinkIdentityName" value="ref:quickLinkIdentityName"/>
    <Arg name="plan" value="ref:plan"/>
    <Transition to="Get Identity Name"/>
  </Step>
  <Step icon="Task" name="Get Identity Name" posX="216" posY="10">
    <Script>
      <Source><![CDATA[
        import sailpoint.object.Identity;
        Identity identityObj=	(Identity)context.getObjectById(Identity.class,quickLinkIdentityName);
        wfcase.put("quickLinkIdentityName",identityObj.getName());

      ]]></Source>
    </Script>
    <Transition to="Build Provisioning Plan"/>
  </Step>
  <Step icon="Provision" name="Build Provisioning Plan" posX="423" posY="10" resultVariable="plan">
    <Arg name="mobile" value="ref:mobile"/>
    <Arg name="quickLinkIdentityName" value="ref:quickLinkIdentityName"/>
    <Arg name="plan" value="ref:plan"/>
    <Script>
      <Source><![CDATA[
        import sailpoint.object.Identity;
        import sailpoint.api.Provisioner;
        import sailpoint.object.ProvisioningProject;
        import sailpoint.object.ProvisioningPlan.ObjectRequest;
        import sailpoint.object.ProvisioningPlan;
        import sailpoint.object.ProvisioningPlan.AccountRequest;
        import sailpoint.object.ProvisioningPlan.AttributeRequest;
        import org.apache.log4j.Logger;

        Logger logger = Logger.getLogger("biontech.workflow.BNT Workflow Add or Update Mobile Number");
        logger.debug("--- ENTRY ---");

        String appName = "BNT Active Directory";
        logger.debug("Starting to Modify AccountRequest Plan for --> " + appName );
        ProvisioningPlan plan = null;

        plan = new ProvisioningPlan();
        ProvisioningPlan.AccountRequest acctReq = new ProvisioningPlan.AccountRequest();

        Identity userObj = context.getObjectByName(Identity.class, quickLinkIdentityName);
        logger.debug("User object is : " + userObj);
        logger.debug("Identity name is : " + quickLinkIdentityName);
        logger.debug("Mobile number  is : " + mobile);
        logger.debug("Starting to build plan...");

        acctReq.setApplication(appName);
        acctReq.setOp(ProvisioningPlan.ObjectOperation.Modify);

        logger.debug("Modify AD Account Attribute...");
        acctReq.add(new AttributeRequest("mobile",ProvisioningPlan.Operation.Set,mobile));
        logger.debug("Modify Account Request...");

        // Account Request created, now add to the Plan

        plan.add(acctReq);
        plan.setIdentity(userObj);      
        plan.addRequester(context.getObjectByName(Identity.class, context.getUserName()));

        // output the Provisioning Plan prior to passing off to be provisioned.
        logger.debug("Provisioning Plan = " + plan.toXml());
        logger.debug("\n Provisioning Plan Completed..............");

        // return the plan so it's available in the workflow for later.
        logger.debug("--- EXIT ---");

        Provisioner PDProvisioner = new Provisioner(context);
        PDProvisioner.setDoRefresh(true);
        ProvisioningProject updateProj = PDProvisioner.compile(plan);
        PDProvisioner.execute();

        return plan;
      ]]></Source>
    </Script>
    <Transition to="FinalConfirmation"/>
  </Step>
  <Step icon="Message" name="FinalConfirmation" posX="596" posY="10">
    <Approval name="ConfirmationFinal" owner="ref:launcher" send="launcher">
      <Arg name="mobile" value="ref:mobile"/>
      <Arg name="quickLinkIdentityName" value="ref:quickLinkIdentityName"/>
      <Form name="ConfirmationFinal" type="WorkflowConfig">
        <Attributes>
          <Map>
            <entry key="pageTitle">
              <value>
                <Script>
                  <Source><![CDATA[
                    return "Requested User "+quickLinkIdentityName+ " mobile number " +mobile+ " Updated!";
                  ]]></Source>
                </Script>
              </value>
            </entry>
          </Map>
        </Attributes>
        <Section type="text">
          <Field displayType="textarea" type="string" value="Your request for updating mobile number has been Completed! Please click on OK to returning back to the home page."/>
        </Section>
        <Button action="next" label="OK"/>
      </Form>
    </Approval>
    <Transition to="end"/>
  </Step>
  <Step icon="Stop" name="end" posX="1000" posY="10"/>
</Workflow>